<?php 
class Lernzirkel_Admin extends Lernzirkel {

    const OPTIONS = array(
        'netsource_lernzirkel_option_tiere' => array('[[0,"Giraffe"],[1,"Kamel"],[2,"Loewe"],[3,"Delfin"],[4,"Fisch"],[5,"Fuchs"],[6,"Hase"],[7,"Igel"],[8,"Leopard"],[9,"Schwan"],[10,"Adler"]]','Liste der Tiere inklusive eindeutiger ID'),
        'netsource_lernzirkel_option_tiertext' => array('Bitte w&auml;hle Dein LOA-Tier', 'Text, der bei der Registrierung vor dem LOA-Tier angezeigt wird'),
        'netsource_lernzirkel_option_registered' => array("Dein Nutzername lautet: {l}<br/>Dein Passwort lautet: {p}<br/>Bitte notiere Dir die Daten. Wir finden sie nicht wieder, wenn sie verloren gehen.<br/><br/>", 'Text, der nach der Registrierung angezeigt wird mit Passwort {p} und Nutzername {l}'),
        'netsource_lernzirkel_option_assistenz' => array("<span class='keineAssistenz'>F&uuml;r dieses Lernerli wird bisher noch keine Assistenz angeboten. Frag doch mal die anderen, wer schon helfen kann.</span>", 'Text, der angezeigt wird, wenn jemand für ein Lernerli "K&ouml;nnen" ausw&auml;hlt (nur relevant mit aktivem Lernerli-Plugin)'),
        'netsource_lernzirkel_option_lernzirkel_noUsers' => array("Du kannst noch keine Nachrichten schreiben. Warte, bis mehr Personen in Deinem Lernzirkel sind.", 'Text, der angezeigt wird, wenn im Lernzirkel noch keine weiteren Personen sind'),
        'netsource_lernzirkel_option_lernzirkel_login' => array("Du bist nicht angemeldet. Bitte melde Dich an.", 'Text, der angezeigt wird, wenn der Lernzirkel aufgerufen wird ohne angemeldet zu sein'),
        'netsource_lernzirkel_option_month_delete_chat' => array(5, 'Monate, nach denen Chat-Nachrichten gelöscht werden'),
        'netsource_lernzirkel_option_minutes_blocked' => array(30, 'Minuten, in denen ein Lernzirkel-Admin geblockt wird, nach Falscheingaben'),
        //'netsource_lernzirkel_option_month_delete_user' => array(12, ''),
        'netsource_lernzirkel_option_count_block' => array(3, 'Anzahl, wie oft ein Lernzirkel-Admin Falscheingaben machen darf vor einer Sperrung'),
        'netsource_lernzirkel_option_count_block_general' => array(3, 'Wie oft darf ein Lernzirkel-Admin tempor&auml;r geblockt werden, bevor er dauerhaft gesperrt wird'),
        'netsource_lernzirkel_option_send_block_mail' => array(true, 'Eine E-Mail senden, wenn Lernzirkel-Admins gesperrt wurden'),
        'netsource_lernzirkel_option_lernzirkel_login_error_temp' => array("Account tempor&auml;r gesperrt!", 'Text nach der Anmeldung, wenn dieser Account tempor&auml;r geblockt wurde'),
        'netsource_lernzirkel_option_lernzirkel_login_error_persistent' => array("Account dauerhaft gesperrt! Bitte kontaktieren Sie die Betreibenden der Seite.", 'Text nach der Anmeldung, wenn der Account dauerhaft gesperrt wurde'),
        'netsource_lernzirkel_option_lernzirkel_unblock' => array("Blockierung aufheben", 'Text im Admin-Bereich, um Lernzirkel-Admins zu entsperren'),
    );
    
    static function get_option_value ($name, $return_default=true) {
        $value = html_entity_decode(stripcslashes(get_option($name)));
        if( empty($value) && $return_default ) {
            $value = Lernzirkel_Admin::get_option_value_default($name);
        }
        return $value;
    }
    
    static function get_option_value_default($name) {
        switch($name) {
            case "netsource_css_lernzirkel":
                return html_entity_decode(stripcslashes(file_get_contents(dirname(__FILE__)."/lernzirkel.css")));
                break;
            case "netsource_javascript_lernzirkel":
                return html_entity_decode(stripcslashes(file_get_contents(dirname(__FILE__)."/lernzirkel.js")));
                break;
        }
        return Lernzirkel_Admin::OPTIONS[$name][0];
    }
    
    private function _save_option ($name) {
        // check user permissions
        if ( !current_user_can('manage_options') ) {
            die(__('Cheatin&#8217; uh?'));
            // if okay, store data
        } else {
            $value = htmlentities($_POST[$name]); //TODO ggf. weiterer Schutz vor XSS?
            update_option($name, $value);
            wp_cache_delete($name);
        }
    }
    
    static function nsrc_add_adminmenu_description_lernkorb () {
        add_menu_page('LOA-Lernzirkel','LOA-Lernzirkel','manage_options','Lernzirkel', array('Lernzirkel_Admin','add_nsrc_lernkorb_adminform'));
    }
    
    /**
     * add Quicktag-Button for lernzirkel-Tag to the html editor
     */
    static function nsrc_lernzirkel_quicktag() {
        if ( wp_script_is( 'quicktags' ) ) {
            ?>
            <script type="text/javascript">
            QTags.addButton( '<?php echo LERNZIRKEL_CHAT_NAME;?>_add', "Lernzirkel-Chat", '[<?php echo LERNZIRKEL_CHAT_NAME;?>]', '[/<?php echo LERNZIRKEL_CHAT_NAME;?>]', 'z', '<?php echo LERNZIRKEL_CHAT_NAME;?>', 1 );
            </script>
            <?php
        }
    }
    
    function nsrc_add_pluginlinks ( $actions ) {
        $mylinks = array(
            '<a href="' . admin_url( 'admin.php?page=Lernzirkel' ) . '">Settings</a>',
            '<a href="' . plugin_dir_url(__FILE__). 'Anleitung.pdf" target=_blank>Anleitung</a>',
        );
        $actions = array_merge( $actions, $mylinks );
        return $actions;
    }
        
    static function add_nsrc_lernkorb_adminform() { ?>
<div class="wrap">
<?php 
	// if submit was pressed, process config data
	if ( isset($_POST['submit']) ) {
		// check user permissions
		if ( !current_user_can('manage_options') ) {
			die(__('Cheatin&#8217; uh?'));
		// if okay, store data
		} else {
		    foreach(Lernzirkel_Admin::OPTIONS as $o => $v) {
		        Lernzirkel_Admin::_save_option($o);
		    }
		    Lernzirkel_Admin::_save_option('netsource_css_lernzirkel');
		    Lernzirkel_Admin::_save_option('netsource_javascript_lernzirkel');
		    echo "<b>Settings saved</b>";
		}
	} 
?>
	<form action="" method="post" id="netsource_lernzirkel" style="margin: auto;">
		<h2>Texte</h2>
<?php 
foreach(Lernzirkel_Admin::OPTIONS as $o => $v) {
?>
		<p><b><label><?php echo $v[1]?> (bitte leer lassen, um den Standard zu nutzen)</label></b></p>
		<input type="text" name="<?php echo $o?>" id="netsource_<?php echo $o?>" value="<?php echo  Lernzirkel_Admin::get_option_value($o, false); ?>"/>
		<div style="color:darkslateblue;"><?php echo  nl2br(Lernzirkel_Admin::get_option_value_default( $o ) ); ?></div>

<?php 
        }
?>
		<h2>CSS und Javascript (f&uuml;r Fortgeschrittene)</h2>
		<p><b><label>CSS (bitte leer lassen, um den Standard zu nutzen)</label></b></p>
	  	<textarea name="netsource_css_lernzirkel" id="netsource_css_lernzirkel" cols="100" rows="10"><?php echo Lernzirkel_Admin::get_option_value("netsource_css_lernzirkel", false); ?></textarea> 
		<div style="color:darkslateblue;"><?php echo  nl2br(Lernzirkel_Admin::get_option_value_default("netsource_css_lernzirkel")); ?></div>

		<p><b><label>Javascript (bitte leer lassen, um den Standard zu nutzen)</label></b></p>
	  	<textarea name="netsource_javascript_lernzirkel" id="netsource_javascript_lernzirkel" cols="100" rows="10"><?php echo  Lernzirkel_Admin::get_option_value("netsource_javascript_lernzirkel", false); ?></textarea> 
		<div style="color:darkslateblue;"><?php echo  nl2br(Lernzirkel_Admin::get_option_value_default("netsource_javascript_lernzirkel")); ?></div>

		<p class="submit"><input type="submit" name="submit" value="<?php _e('Update Settings&raquo;'); ?>" /></p>
		
	</form>
</div>
<?php
    }

    //Spalte für Sperrung ergänzen
    function manage_users_columns($columns) {
        $columns["blocked"] = "Sperrung tempor&auml;r";
        $columns["blocked_general"] = "Sperrung dauerhaft";
        return $columns;
    }
    function manage_users_custom_column($x, $name, $id) {
        if( $name != "blocked" && $name != "blocked_general" ) return ;
        $user = get_userdata($id);
        $count_general = intval(get_usermeta( $user->ID, LERNZIRKEL_METAKEY_BLOCK_COUNT_GENERAL ));
        if( $name == "blocked" ) {
            if( $count_general >= Lernzirkel_Admin::get_option_value('netsource_lernzirkel_option_count_block_general') )
                return '<span style="color:red;">Dauerhaft gesperrt!</span>';
            $count = intval(get_usermeta( $user->ID, LERNZIRKEL_METAKEY_BLOCK_COUNT ));
            if( $count > 0 ) {
                $date = get_usermeta( $user->ID, LERNZIRKEL_METAKEY_BLOCK_DATE );
                $date1 = mktime ( date("H",$date)+2 , date("i",$date)+Lernzirkel_Admin::get_option_value('netsource_lernzirkel_option_minutes_blocked'), date("s",$date) , date("n",$date) , date("j",$date) , date("Y,$date")); 
//                 Lernzirkel_Admin::get_option_value('netsource_lernzirkel_option_minutes_blocked')
                if( $count >= Lernzirkel_Admin::get_option_value('netsource_lernzirkel_option_count_block') ) $date = "<br/>Gesperrt bis:<br/>".date("d.m.Y H:i:s", $date1);
                else $date = "";
                return $count." / ".Lernzirkel_Admin::get_option_value('netsource_lernzirkel_option_count_block').$date;
            }
        }
        if( $name == "blocked_general" ) {
            if( $count_general > 0 ) {
                $text = $count_general." / ".Lernzirkel_Admin::get_option_value('netsource_lernzirkel_option_count_block_general');
                if( $count_general >= Lernzirkel_Admin::get_option_value('netsource_lernzirkel_option_count_block_general') )
                    $text = '<span style="color:red;">Dauerhaft gesperrt!</span>';
                return $text;
            }
        }
        
    }
    
    function register_my_bulk_actions($bulk_actions) {
        $bulk_actions['unblock'] = __( 'entsperren', 'unblock');
        return $bulk_actions;
    }
    
    function my_bulk_action_handler( $redirect_to, $doaction, $user_ids ) {
        if ( $doaction != "unblock" || ! current_user_can('manage_options') ) {
            return $redirect_to;
        }
        foreach ( $user_ids as $user_id) {
            delete_usermeta($user_id, LERNZIRKEL_METAKEY_BLOCK_DATE );
            delete_usermeta($user_id, LERNZIRKEL_METAKEY_BLOCK_COUNT );
            delete_usermeta($user_id, LERNZIRKEL_METAKEY_BLOCK_COUNT_GENERAL );
            delete_usermeta($user_id, LERNZIRKEL_METAKEY_BLOCK_IP );
        }
        return $redirect_to;
    } 
}

?>