<?php 

class Lernzirkel_Frontend extends Lernzirkel {
    /**
     * Shortcode: Anzeigen von Lernzirkel-Chats für einen Post für angemeldeten Nutzer oder mit allen aus Lernzirkel
     * Chat an Lernende, die Assistenz anbieten (Stufe:5)
     * [lernzirkel_chat lernerli_id="12345"]
     */
    function nsrc_lernzirkel_chat_shortcode( $atts ) {
        global $wpdb;
        $user_id = get_current_user_id();
        if( ! $user_id ) {
            //fuer einen Lernerli keine Meldung anzeigen
            if( ! empty($atts) && ! empty($atts["lernerli_id"]) && ! empty(Lernkorb::LERNERLI_id) ) {
                return "";
            }
            return Lernzirkel_Admin::get_option_value('netsource_lernzirkel_option_lernzirkel_login');
        }
        $post_id = get_queried_object_id();
        $user = get_user_by('id', $user_id);
        
        //Nachrichten lesen und schreiben
        $lern = '';
        $nachricht_title = 'Nachricht schreiben';
        $chat_to = array();
        //Chat für einen Lernerli oder Chat für alle im Lernzirkel
        if( ! empty($atts) && ! empty($atts["lernerli_id"]) && ! empty(Lernkorb::LERNERLI_id) ) {
            
            //Chat für Lernerli, nicht für Lernzirkel
            $lern = '<input type="hidden" name="lernzirkel_chat_'.Lernkorb::LERNERLI_id.'" value="'.$atts["lernerli_id"].'"/>';
            $nachricht_title = 'Um Assistenz f&uuml;r dieses Lernerli bitten';
            //prüfen, ob lernerli bei aktuellem user türkis und wenn nicht, return
            $sql =  "
                SELECT meta_value
                FROM ".$wpdb->users." u1
                LEFT JOIN ".$wpdb->usermeta." u2 ON u2.user_id = u1.ID
                WHERE meta_key = 'lernerli' AND (meta_value='".$atts["lernerli_id"].":3' or  meta_value='".$atts["lernerli_id"].":5') and u1.ID = $user_id
                ORDER BY display_name DESC";
            $meta_v = $wpdb->get_var( $sql );
            if( ! empty($meta_v) && preg_match("/\:[35]$/", $meta_v) ) {
                //TODO "lernerli" aus Konstante holen und "5" weitergeben und "3" können
                //Alle laden, die Assistenz anbieten, wenn Assistenz gefordert
                if(preg_match("/\:[3]$/", $meta_v) ){
                    $sql =  "
                        SELECT u1.display_name as name, ID
                        FROM ".$wpdb->users." u1
                        LEFT JOIN ".$wpdb->usermeta." u2 ON u2.user_id = u1.ID
                        WHERE meta_key = '".Lernkorb::LERNERLI_id."' AND meta_value='".$atts["lernerli_id"].":5'
                        ORDER BY display_name DESC";
                    $chat_to = $wpdb->get_results( $sql, ARRAY_A );
                    if( empty($chat_to) ) $return .= Lernzirkel_Admin::get_option_value('netsource_lernzirkel_option_assistenz');
                }
                //alle laden, mit denen ich zu diesem Lernerli schon einmal kontakt hatte
                $sql =  "
                    SELECT u1.display_name as name, u1.ID
                    FROM ".$wpdb->users." u1
                    LEFT JOIN ".$wpdb->prefix.LERNZIRKEL_CHAT_NAME." c1 on (c1.user_id_from = u1.ID)
                    LEFT JOIN ".$wpdb->prefix.LERNZIRKEL_CHAT_NAME." c2 on (c2.user_id_to = u1.ID)
                    WHERE (c1.".Lernkorb::LERNERLI_id."_id =".$atts["lernerli_id"]." or c2.".Lernkorb::LERNERLI_id."_id =".$atts["lernerli_id"].")
                    GROUP BY u1.ID
                    ORDER BY display_name DESC";
                $chat_to1 = $wpdb->get_results( $sql, ARRAY_A );
                $chat_to =  array_merge($chat_to, $chat_to1);
                $chat_to =  array_unique($chat_to);
            }
        } else {
            //ACHTUNG noch besser testen!
            //alle Empfänger aus Lernzirkel
            $sql =  "
                SELECT u1.display_name as name, u1.ID
                FROM ".$wpdb->users." u1
                LEFT JOIN ".$wpdb->prefix.LERNZIRKEL_2USER." lz on lz.user_id = u1.ID
                WHERE lz.lernzirkel_id IN(
                    select lernzirkel_id
                        from ".$wpdb->prefix.LERNZIRKEL_2USER." lz1
                        LEFT JOIN ".$wpdb->prefix.LERNZIRKEL_NAME." lz on lz1.lernzirkel_id = lz.id
                        where lz1.user_id=$user_id or lz.created_by = $user_id
                )
                AND u1.ID!=$user_id
				GROUP BY u1.ID
                ORDER BY display_name DESC";
            $chat_to = $wpdb->get_results( $sql, ARRAY_A );
            if( empty($chat_to) ) {
                $return .= Lernzirkel_Admin::get_option_value('netsource_lernzirkel_option_lernzirkel_noUsers');
            }
        }
        if( ! empty($chat_to) ) {
            //formular für neue chatnachrichten
            $return .= '
            <form name="lernzirkel_chat" class="lernzirkel_chat lernzirkel_admin" method="post" action="'.get_the_permalink($post_id).'">
            <h2>'.$nachricht_title.'</h2>
            Du bist angemeldet als '.$user->user_login.'
                
    		<label>An:</label>
            '.$lern.'
            <select name="lernzirkel_chat_to">';
            foreach($chat_to as $to) {
                $return .= '
    		    <option value="'.intval($to['ID']).'" class="loa_tier_'.Lernzirkel::login2Tier($to['name']).'">'.$to['name'].'</option>';
            }
            $return .= '
    		</select>';
            $return .= '
            	<label>Nachricht:</label>
            	'.$attfield.'
            	<textarea rows="3" cols="10" value="Hier Deine Nachricht eingeben..." name="lernzirkel_chat"></textarea>
            	<input type="submit" value="Absenden" name="lernzirkel_button"/>
            </form>';
        }
        //vorhandene chats anzeigen
        $l_sql = " AND post_id = $post_id ";
        if( ! empty($atts) && intval($atts["lernerli_id"]) > 0 ) {
            $l_sql = " AND lernerli_id=".intval($atts["lernerli_id"])." ";
            $attfield = '<input type="hidden" name="lernzirkel_chat_lernerli" value="'.intval($atts["lernerli_id"]).'"/>';
        }
        $chats = $wpdb->get_results( $wpdb->prepare("
            SELECT ".$wpdb->prefix.LERNZIRKEL_CHAT_NAME.".*, u1.display_name as name_from, u2.display_name as name_to
            FROM ".$wpdb->prefix.LERNZIRKEL_CHAT_NAME."
            LEFT JOIN ".$wpdb->users." u1 ON u1.ID = ".$wpdb->prefix.LERNZIRKEL_CHAT_NAME.".user_id_from
            LEFT JOIN ".$wpdb->users." u2 ON u2.ID = ".$wpdb->prefix.LERNZIRKEL_CHAT_NAME.".user_id_to
            WHERE (user_id_from = %d OR user_id_to = %d) ".$l_sql."
            ORDER BY created_at DESC", $user_id , $user_id  ) );
        if( ! empty($chats) ) {
            $return .= '<div id="lernzirkel_chat_eintraege">
            <h2>Nachrichten lesen</h2>
            ';
            foreach($chats as $c) {
                $return .= '
            	<div class="lernzirkel_chat_eintrag">
                	<div class="lernzirkel_chat lernzirkel_chat_author lernzirkel_chat_author_'.Lernzirkel::login2Tier($c->name_from).'">'.$c->name_from.'</div>
                	<div class="lernzirkel_chat lernzirkel_chat_to lernzirkel_chat_to_'.Lernzirkel::login2Tier($c->name_to).'">'.$c->name_to.'</div>
                	<div class="lernzirkel_chat lernzirkel_chat_time">'.mysql2date(get_option( 'date_format' ),$c->created_at).', '.mysql2date(get_option( 'time_format' ),$c->created_at).'</div>
                	<div class="lernzirkel_chat lernzirkel_chat_message">'.nl2br(htmlentities($c->message)).'</div>
    			</div>';
            }
            $return .= '</div>';
        }
        
        
        
        if( empty($atts["lernerli_id"]) ) {
            if( in_array( "lernzirkel_admin", (array) $user->roles ) || current_user_can('manage_options') ) {
                global $lernzirkel_error;
                if ( is_wp_error( $lernzirkel_error ) ) {
                    foreach ( $lernzirkel_error->get_error_messages() as $error ) {
                        $return .=  '<div><strong>Fehler</strong>:'.$error . '<br/></div>';
                    }
                }
                //formular für neue lernzirkel
                $return .= '
                <form name="lernzirkel_admin" class="lernzirkel_admin" method="post" action="'.get_the_permalink($post_id).'">
            		<h2>Lernzirkel anlegen</h2>
                    <label for="lernzirkel_name">Name:</label><input type="text" name="lernzirkel_name" id="lernzirkel_name"/>
                	<input type="submit" value="Absenden" name="lernzirkel_button"/>
                </form>
                ';
                
                //alle Lernzirkel laden
                $sql =  "
                        SELECT name, ID
                        FROM ".$wpdb->prefix.LERNZIRKEL_NAME."
                        WHERE created_by=$user_id
                        ORDER BY name DESC";
                $lernzirkel = $wpdb->get_results( $sql );
                
                //formular für Nutzer zu lernzirkel
                if( ! empty($lernzirkel) ) {
                    $return .= '
                    <form name="lernzirkel_admin_user" class="lernzirkel_admin" method="post" action="'.get_the_permalink($post_id).'">
            		<h2>Nutzende zu Lernzirkel hinzuf&uuml;gen</h2>
                    <label for="lernzirkel_name">Nutzername:</label><input type="text" name="lernzirkel_username" id="lernzirkel_username"/>
                    <label for="lernzirkel_id">Lernzirkel:</label><select name="lernzirkel_id" id="lernzirkel_id">';
                    foreach($lernzirkel as $lz) {
                        $return .= '
                		    <option value="'.intval($lz->ID).'">'.$lz->name.'</option>';
                    }
                    $return .= '
            		</select>
                	<input type="submit" value="Absenden" name="lernzirkel_button"/>
                    </form>
                    ';
                }
            
                //nutzende von lernzirkel löschen
                if( ! empty($lernzirkel) ) {
                    $count = 0;
                    $return .= '
                        <form name="lernzirkel_admin_user" class="lernzirkel_admin" method="post" action="'.get_the_permalink($post_id).'">
                            <h2>Nutzende von Lernzirkel l&ouml;schen</h2>
                        ';
                    foreach($lernzirkel as $lz) {
                        $sql =  "
                        SELECT u1.display_name as name, ID
                        FROM ".$wpdb->users." u1
                        LEFT JOIN ".$wpdb->prefix.LERNZIRKEL_2USER." lz on lz.user_id = u1.ID
                        WHERE lz.lernzirkel_id = ".$lz->ID." AND created_by=$user_id
                        ORDER BY display_name DESC";
                        $userlernzirkel = $wpdb->get_results( $sql );
                        if( ! empty($userlernzirkel ) ) {
                            $count++;
                            $return .= '
                                <h2>'.$lz->name.'</h2>';
                            foreach($userlernzirkel as $u) {
                                $return .= '<input type="radio" name="delete_lernzirkel2user" value="'.intval($lz->ID).':'.intval($u->ID).'" id="delete_lernzirkel2user'.$lz->ID.':'.intval($u->ID).'"/>
                                                    <label for="delete_lernzirkel2user'.$lz->ID.':'.intval($u->ID).'">'.$u->name.'</label>';
                            }
                        }
                    }
                    if( $count > 0 ) {
                        $return .= '
                            	<input type="submit" value="Absenden" name="lernzirkel_button" class="lernzirkel_delete"/>
                            </form>
                                ';
                    } else $return .= 'Noch keine Daten vorhanden</form>';
                }
                //lernzirkel löschen
                if( ! empty($lernzirkel) ) {
                    $return .= '
                    <form name="lernzirkel_admin_delete" class="lernzirkel_admin" method="post" action="'.get_the_permalink($post_id).'">
                    <h2>Lernzirkel l&ouml;schen (inklusive Zuordnung der Nutzenden)</h2>
                    ';
                    foreach($lernzirkel as $lz) {
                        $return .= '
            		    <input type="radio" name="delete_lernzirkel" value="'.intval($lz->ID).'" id="delete_lernzirkel'.$lz->ID.'"/><label for="delete_lernzirkel'.$lz->ID.'">'.$lz->name.'</label>';
                    }
                    $return .= '
                	<input type="submit" value="Absenden" name="lernzirkel_button" class="lernzirkel_delete"/>
                    </form>
                    ';
                }
            }
        }
        
        return $return;
    }
    
    /**
     * save lernzirkel and users for lernzirkel
     */
    static function nsrc_add_lernzirkel( $wp_query ) {
        global $wpdb;
        $user_id = get_current_user_id();
        
        if( ! empty($wp_query->query['lernzirkel_name']) ) {
            //TODO mehrfaches absenden vermeiden
            //TODO hier XSS-Schutz
            $wpdb->query( $wpdb->prepare("
                INSERT INTO ".$wpdb->prefix.LERNZIRKEL_NAME."(name, created_by) VALUES('%s', %d)
                ", $wp_query->query['lernzirkel_name'], $user_id ) );
        }
        if( ! empty($wp_query->query['lernzirkel_id']) && ! empty($wp_query->query['lernzirkel_username']) ) {
            //TODO mehrfaches absenden vermeiden
            //TODO hier XSS-Schutz
            $user1 = get_user_by('login', $wp_query->query['lernzirkel_username']);
            //user unbekannt, dann Zähler für Falscheingaben hoch setzen. Wenn zu oft falsch, dann sperren und IP merken
            if( $user1 === false ) {
                $date = get_usermeta( $user_id, LERNZIRKEL_METAKEY_BLOCK_DATE );
                if( empty($date) ) {
                    update_usermeta($user_id, LERNZIRKEL_METAKEY_BLOCK_DATE, mktime() );
                }
                $count = intval(get_usermeta( $user_id, LERNZIRKEL_METAKEY_BLOCK_COUNT ));
                $count++;
                update_usermeta($user_id, LERNZIRKEL_METAKEY_BLOCK_COUNT, $count );
                
                // Make the WP_Error object global
                global $lernzirkel_error;
                $lernzirkel_error = new WP_Error;
                $lernzirkel_error->add( 'user_unknown', 'Dieser Benutzername existiert nicht! Du hast bereits '.$count.' von '.Lernzirkel_Admin::get_option_value('netsource_lernzirkel_option_count_block').' Fehleingaben gemacht!' );
                
                if( $count >= Lernzirkel_Admin::get_option_value('netsource_lernzirkel_option_count_block') ) {
                    $ip = "";
                    if ( ! empty( $_SERVER['HTTP_CLIENT_IP'] ) ) {
                        //check ip from share internet
                        $ip = $_SERVER['HTTP_CLIENT_IP'];
                    } elseif ( ! empty( $_SERVER['HTTP_X_FORWARDED_FOR'] ) ) {
                        //to check ip is pass from proxy
                        $ip = $_SERVER['HTTP_X_FORWARDED_FOR'];
                    } else {
                        $ip = $_SERVER['REMOTE_ADDR'];
                    }
                    update_usermeta($user_id, LERNZIRKEL_METAKEY_BLOCK_IP, $ip );
                    //generelles Blocken hochzählen, falls user ganz gesperrt werden muss
                    $count = intval(get_usermeta( $user_id, LERNZIRKEL_METAKEY_BLOCK_COUNT_GENERAL ));
                    $count++;
                    update_usermeta($user_id, LERNZIRKEL_METAKEY_BLOCK_COUNT_GENERAL, $count );
                    
                    //informieren, dass user gesperrt
                    if( $count >= Lernzirkel_Admin::get_option_value('netsource_lernzirkel_option_count_block_general') ) {
                        if( Lernzirkel_Admin::get_option_value('netsource_lernzirkel_option_send_block_mail') === true ) {
                            $user = get_userdata($user_id);
                            $headers = 'From: '.get_option( 'blogname' )."<". get_option( 'admin_email' ) . ">\r\n";
                            $body = "Der Nutzer ".$user->user_login." wurde dauerhaft gesperrt, weil er ".Lernzirkel_Admin::get_option_value('netsource_lernzirkel_option_count_block_general')." mal für ".Lernzirkel_Admin::get_option_value('netsource_lernzirkel_option_minutes_blocked')." Minuten gesperrt wurde.";
                            wp_mail(  get_option('admin_email'), __("Nutzer gesperrt, bitte kontrollieren!"), __($body), $headers);
                        }
                    }
                    wp_logout();
                }
            } else {
                $wpdb->query( $wpdb->prepare("
                    INSERT INTO ".$wpdb->prefix.LERNZIRKEL_2USER."(lernzirkel_id, user_id, created_by) VALUES(%d, %d, %d)
                    ", intval($wp_query->query['lernzirkel_id']), $user1->ID, $user_id ) );
            }
        }
        if( ! empty($_POST['delete_lernzirkel']) && intval($_POST['delete_lernzirkel']) > 0 ) {
            $wpdb->query( $wpdb->prepare("
                DELETE n1,n2 FROM ".$wpdb->prefix.LERNZIRKEL_NAME." n1
                LEFT JOIN ".$wpdb->prefix.LERNZIRKEL_2USER." n2 ON n1.ID = n2.lernzirkel_id
                WHERE n1.ID = %d AND n1.created_by= %d
                ", intval($_POST['delete_lernzirkel']), $user_id ) );
        }
        if( ! empty($_POST['delete_lernzirkel2user']) ) {
            list($lernzirkel, $uid) = explode(":", $_POST['delete_lernzirkel2user']);
            $wpdb->query( $wpdb->prepare("
                DELETE FROM ".$wpdb->prefix.LERNZIRKEL_2USER." where lernzirkel_id=%d
                AND user_id = %d
                ", intval($lernzirkel), intval($uid ) ) );
        }
        
    }
    
    /**
     * check if there is a valid user id, stufe and lernerli_id, if so, add it to user_meta
     */
    static function nsrc_add_chat_2_user( $wp_query ) {
        global $wpdb;
        if( ! empty($wp_query->query['lernzirkel_chat']) && ! empty($wp_query->query['lernzirkel_chat_to']) ) {
            $user_id = get_current_user_id();
            $post_id = get_queried_object_id();
            //TODO mehrfaches absenden vermeiden
            //TODO hier XSS-Schutz
            $x = $wpdb->query( $wpdb->prepare("
                INSERT INTO ".$wpdb->prefix.LERNZIRKEL_CHAT_NAME."(message,user_id_from, user_id_to,post_id,lernerli_id) VALUES('%s', %d, %d, %d, %d)
                ", $wp_query->query['lernzirkel_chat'], $user_id, intval($wp_query->query['lernzirkel_chat_to']) , $post_id, intval($wp_query->query['lernzirkel_chat_lernerli']) ) );
        }
    }
    
    /**
     * Allow the following params in the URL to add lernerli to usermeta
     */
    static function nsrc_add_query_vars($vars) {
        $vars[] .= 'lernzirkel_chat';
        $vars[] .= 'lernzirkel_chat_to';
        $vars[] .= 'lernzirkel_chat_lernerli';
        $vars[] .= 'lernzirkel_name';
        $vars[] .= 'lernzirkel_username';
        $vars[] .= 'lernzirkel_id';
        $vars[] .= 'delete_lernzirkel';
        
        return $vars;
    }
    
    /**
     * Javascript und CSS einbinden
     */
    function nsrc_add_stylesheet_head() {
        wp_enqueue_style( 'lernzirkel', plugins_url('lernzirkel.css',__FILE__));
        wp_enqueue_script( 'lernzirkeljs', plugins_url('lernzirkel.js',__FILE__));
    }
    
    /**
     * Cron: Alte Chats löschen
     * TODO MOnate: 0=egal
     */
    function lernzirkel_chat_loeschen() {
        global $wpdb;
        $date1 = mktime(0, 0, 0, date("m")-Lernzirkel_Admin::get_option_value('netsource_lernzirkel_option_month_delete_chat'), date("d"), date("Y"));
        $date2 = date('Y-m-d', $date1);
        $sql = "DELETE FROM ".$wpdb->prefix.LERNZIRKEL_CHAT_NAME." WHERE created_at < '".$date2."'" ;
        $wpdb->query( $sql);
    }
    /**
     * Cron: Ungenutzte User löschen
     * TODO Monate  0=egal
     */
    function lernzirkel_delete_old_user() {
        return;
        global $wpdb;
        $date1 = mktime(date("H"), date("i"), date("s"), date("m")-Lernzirkel_Admin::get_option_value('netsource_lernzirkel_option_month_delete_user'), date("d"), date("Y"));
        $date2 = date('Y-m-d H:i:s', $date1);
        //TODO ggf. umsetzen: Cron: Ungenutzte User löschen
        //         $sql = "DELETE FROM ".$wpdb->prefix.LERNZIRKEL_CHAT_NAME." WHERE created_at < '".$date2."'" ;
        //         $wpdb->query( $sql);
    }
    /**
     * Cron: User entsperren
     */
    function lernzirkel_reactivate_user_afterMinutes() {
        global $wpdb;
        $date1 = mktime(date("H"), date("i")-Lernzirkel_Admin::get_option_value('netsource_lernzirkel_option_minutes_blocked'), date("s"), date("m"), date("d"), date("Y"));
        $usermetas = $wpdb->get_results( $wpdb->prepare("SELECT * FROM $wpdb->usermeta WHERE meta_key = %s AND meta_value<%d", LERNZIRKEL_METAKEY_BLOCK_DATE, $date1) );
        foreach($usermetas as $u) {
            $user_id = $u->user_id;
            $count = intval(get_usermeta( $user_id, LERNZIRKEL_METAKEY_BLOCK_COUNT_GENERAL ));
            if( $count < Lernzirkel_Admin::get_option_value('netsource_lernzirkel_option_count_block_general') ) {
                delete_usermeta($user_id, LERNZIRKEL_METAKEY_BLOCK_DATE );
                delete_usermeta($user_id, LERNZIRKEL_METAKEY_BLOCK_COUNT );
            }
            //TODO IP löschen oder besser gespeichert lassen? delete_usermeta($user_id, LERNZIRKEL_METAKEY_BLOCK_IP );
        }
    }
        
    /**
     * Throw error if user is blocked
     * @param WP_Error $errors
     */
    function nsrc_lernzirkel_block_user_from_login_error( $x, $username, $password ) {
        $errors = new WP_Error();
        $user = get_userdatabylogin($username);
        
        $count = intval(get_usermeta( $user->ID, LERNZIRKEL_METAKEY_BLOCK_COUNT_GENERAL ));
        if( $count >= Lernzirkel_Admin::get_option_value('netsource_lernzirkel_option_count_block_general') ) {
            $errors->add('blocked', Lernzirkel_Admin::get_option_value('netsource_lernzirkel_option_lernzirkel_login_error_persistent'));
            return $errors;
        }
        
        $count = intval(get_usermeta( $user->ID, LERNZIRKEL_METAKEY_BLOCK_COUNT ));
        if( $count >= Lernzirkel_Admin::get_option_value('netsource_lernzirkel_option_count_block') ) {
            $errors->add('blocked', Lernzirkel_Admin::get_option_value('netsource_lernzirkel_option_lernzirkel_login_error_temp'));
            return $errors;
        }
        
        return $x;
    }
}

?>