<?php 
class Lernzirkel_UserRegistration extends Lernzirkel {
    /**
     * Link ergaenzen, damit Nutzer entsperrt werden kann
     */
    function nsrc_useraction_unlockuserlink($actions, $user) {
        $count = intval(get_usermeta( $user->ID, LERNZIRKEL_METAKEY_BLOCK_COUNT_GENERAL ));
        if( $count >= Lernzirkel_Admin::get_option_value('netsource_lernzirkel_option_count_block_general') ) {
            $actions['unlock'] = "<a class='lernzirkel_unlock' href='users.php?action=unlocklernzirkel&amp;user=".$user->ID."&amp;_wpnonce=".wp_create_nonce( 'lernzirkel_unlock_' . $user->ID)."'>".Lernzirkel_Admin::get_option_value('netsource_lernzirkel_option_lernzirkel_unblock')."</a>";
        }
        return $actions;
    }
    
    /**
     * Nutzer freischalten
     */
    function nsrc_useraction_unlockuser() {
        if( isset($_GET['action']) && $_GET['action'] === "unlocklernzirkel" && isset($_GET['user']) && intval($_GET['user']) > 0 ) {
            if( wp_verify_nonce( $_GET['_wpnonce'], 'lernzirkel_unlock_' . intval($_GET['user']) ) ) {
                if( current_user_can('edit_users') ) {
                    delete_usermeta( intval($_GET['user']), LERNZIRKEL_METAKEY_BLOCK_COUNT_GENERAL );
                    delete_usermeta( intval($_GET['user']), LERNZIRKEL_METAKEY_BLOCK_COUNT );
                }
            }
        }
    }
    
    /**
     * Dem Nutzenden nach der Registrierung das Passwort anzeigen
     */
    function login_form_fertig() {
        $text = str_replace("{l}", '<span class="reg_user">'.$_GET['log'].'</span>', Lernzirkel_Admin::get_option_value('netsource_lernzirkel_option_registered'));
        $text = str_replace("{p}", '<span class="reg_pwd">'.$_GET['pwd'].'</span>', $text);
        print $text;
    }
    
    /**
     * Username berechnen
     */
    function login_init() {
        if( isset($_POST['loa_tier'])  ) {
            $tiere = json_decode(Lernzirkel_Admin::get_option_value('netsource_lernzirkel_option_tiere'));
            $i = 8999;
            $_POST['user_login'] = $tiere[intval($_POST['loa_tier'])][1].random_int(1000, 9999);
            while(username_exists($_POST['user_login']) && $i > 0) {
                $i--;
                $_POST['user_login'] = $tiere[intval($_POST['loa_tier'])][1].random_int(1000, 9999);
            }
            if( username_exists($_POST['user_login']) ) die("Bitte w&auml;hle ein anderes Tier!");
        }
    }
    
    /**
     * User-Email ausblenden und Username-Wert "wird berechnet"
     */
    function login_head() {
        ?>
		<link rel="stylesheet" id="" href="<?php echo plugins_url('lernzirkel.css',__FILE__)?>" type="text/css" media="all">
		<?php         
        if( ! empty($_REQUEST) && ! empty($_REQUEST['action']) && $_REQUEST['action'] == "register" ) {
            ?>
            <script type="text/javascript">
            window.onload = function () {
    	        var x = document.getElementById("user_login");
    	        x.disabled = true;
    	        if( x.value === "") x.value = "Wird berechnet ...";
    	        
    	        var x = document.getElementById("loa_tier");
    	        x.onchange = function () {
    	        	x.className="loa_tier_"+x.selectedIndex;
    	        }
            }
            </script>
    <?php
        }
    }
    
    /**
     * als username "wird berechnet" anzeigen (falls kein Javascript aktiviert)
     */
    function registration_setUsername() {
        if( is_user_logged_in() ) return;
        if( empty( $_POST ) ) $_POST['user_login'] = "wird berechnet";
    }

    /**
     * Fehler entfernen, damit user keine Email eingeben muss
     */
    function user_profile_update_errors($errors, $login, $user) {
        //user must no share an email address
        $errors->remove('empty_email');
        return $errors;
    }

    /**
     * Passwort setzen und weiterleiten zu Login
     */
    function register_new_user($uid) {
        $u = get_user_by('id', $uid);
        $u->set_role('lernzirkel');
        $password = wp_generate_password( 8 );
        $password = str_replace("&", "X", $password);
        $password = str_replace("/", "Y", $password);
        $password = str_replace("#", "Z", $password);
        $_POST['user_password'] = $password;
        wp_set_password( $_POST['user_password'], $u->ID );

        $_POST['redirect_to'] = wp_login_url()."?action=fertig&log=".$u->user_login."&pwd=".$password;
    }
    
    /**
     * LOA-Tiere Select-Feld anzeigen
     */
    function registration_form() {
        if( $_REQUEST['action'] != "register" ) return;
        
        ?>
        <?php 
//         if( ! empty( $_POST['user_password'] ) ) return;
        ?>
    <p>
        <label for="loa_tier"><?php echo Lernzirkel_Admin::get_option_value('netsource_lernzirkel_option_tiertext')?> </label>
        <select name="loa_tier" id="loa_tier"> 
        <?php foreach(json_decode(Lernzirkel_Admin::get_option_value('netsource_lernzirkel_option_tiere')) as list($index,$value)):?>
        	<option value="<?php echo $index?>" class="loa_tier_<?php echo $index?>"><?php echo $value?></option>
        <?php endforeach?>
        </select>
    </p>
 
    <?php
    }
}

?>